#include <torch/torch.h>
#include <iostream>

//#include <torch/Aten/Function.h>
namespace F = torch::nn::functional;
using namespace torch::nn;


int main(int argc, char **argv){
   torch::DeviceType device_type;
   if(torch::cuda::is_available()){
     std::cout << "CUDA available! Training on GPU." << std::endl;
     device_type = torch::kCUDA;
   } else{
     std::cout << "Training on CPU." << std::endl;
     device_type = torch::kCPU;
   }
   torch::Device device(device_type);
   //torch::tensor input;
   //input = torch::rand(16, 64, 32, 32);
   //auto x = torch::arange(50.).view({1, 2, 5, 5});
   auto input = torch::arange(1048576.).view({16, 64, 32, 32});
   input.to(device);
   auto weight = torch::arange(4096).view({64, 1, 8, 8});
   weight.to(device);
//   c10::IntArrayRef stride;
//   c10::IntArrayRef padding;
//   c10::IntArrayRef output_padding;
//   c10::IntArrayRef dilation;
   const int64_t stride   = 1;
   const int64_t padding  = 2;
   const int64_t dilation  = 1;
   //F::conv_transpose2d(input, weight, {}, stride, padding);
   torch::conv_transpose2d(input, weight);
   return 0;
   

}
